//         
// Digigripper   
//           
// Olaf Val 
// www.olafval.de     
//                       

import processing.serial.*;

Serial comPort;        // The serial port
int comNum = 1; // Nummer of comPort in comPortList (devault:0)
String inString;  // Variable for Serial Data
String outString;
String testString;

int timer = 0;
int speed = 1000;
int textMax = 35;
int playMax = 5;
int playMaxEx;

int newInput = 0;
int enter = 0;
int[] input = new int[textMax];
int[] play = new int[textMax];
int[] playEx = new int[textMax];

int step=1;
int sentKey = -1;  // Keyboard Key to bee sent
PFont fontA;        // Font for printing
int k; // The currend key
int gripper = 1;
int playerLetter;

int pause;


void setup() {
  size(800, 600);

  // Load and prep fonts to print to window
  fontA = loadFont("CourierNewPSMT-24.vlw");
  textFont(fontA, 25);
  
  clearPlay();
  
  clearInput();
  
  // List all the available serial ports.
  println(Serial.list());
  comPort = new Serial(this, Serial.list()[comNum], 9600);
}

void draw() {
  if (pause > 0) {
    wait(pause);
    pause = 0;
  }
  background(30);
  
  // title
  fill(200);
  text("Now playing", 18, 180);
  
  fill(200);
  text("Type your text!", 18, 340);
  
  //Button
  if ((mouseX > 705) && (mouseX < 705 + 80) && (mouseY > 420) && (mouseY < 420 + 25)){
    fill(255,0,0);

    if (mousePressed == true) {
      if (newInput == 0){
        newInput = 1;
        processText();
        checkText();
      }
    } else {
      newInput=0;
    }
  }else{
    fill(200);
  }

  text("Enter", 710, 440);
  
  if ((mouseX > 705) && (mouseX < 705 + 80) && (mouseY > 420) && (mouseY < 420 + 25)){
    stroke(255,0,0);
  }else{
    stroke(200);
  }
  noFill();
  rect(705, 420, 80, 25);
  
  // draw INPUT rect plus text -------------------
  for(int i = 0; i < (textMax); i=i+1){
    
    //cursor
    if (step==i){
    fill(255);
    } else {
    noFill();
    }
    
    stroke(200);

    
    //detect SPACE
    if (input[i] == 32) {
      fill(200);
    }
    rect(18+(i*22), 362, 20, 30);
    
    fill(200);
    text(char(input[i]), 21+(i*22), 362+20);
  }
    
  // draw PLAY rect plus text --------------------
  for(int i = 0; i < (playMax); i=i+1){  
    if (gripper==i){
      stroke(255,0,0);
    } else {
      stroke(200);
    }
    //detect SPACE
    if (play[i] == 32) {
      if (gripper == i) {
        fill(255,0,0);
      } else {
        fill(200);
      } 
    } else {
      noFill();
    }
    rect(18+(i*22), 200, 20, 30);
    
    if (gripper==i){
      fill(255,0,0);
      playerLetter = play[i];
    } else {
      fill(200);
    }
    text(char(play[i]), 21+(i*22), 200+20);
    
    //Timer to move gripper
    if (millis() > timer + speed){
      timer = millis();
      gripper ++;
      
      //send the currend Letter to the ComPort
      comPort.write(playerLetter);
      
      if(gripper > playMax-2){
        gripper = 1;
      }
    } 
  }


  // If there are bytes available in the input ComPortBuffer, read them into inString.
 // while (comPort.available() > 0) {
 //   inString = comPort.readString();
  //}
}

// keyboard interaction -----------------------------------
void keyPressed() {

  k = keyCode;
  
  //BackSpace
  if (k == 8) {
    step --;
    if (step<1){
      step = 1;
    }
    input[step] = 95;
  } 
  
    //del
  if (k == 127) {
    input[step] = 95;
  } 
  
  //cursor left
  if (k == 37) {
    step --;
    if (step<1){
      step = 1;
    }
  }
  
  // cursur right
  if (k == 39) {
    step ++;
    if (step>textMax-2){
      step = textMax-2;
    }
  }
  
  /* 10 = Enter
  16, 17, 18 = Shift, Alt, AltGr
  */
  // enter
  if (k == 10) {
    if (newInput == 0){
      newInput = 1;
      processText();
      checkText();
      }
  } else {
    newInput = 0;
  }
  
  if ((k != 8)&&(k != 37)&&(k != 39)&&(k != 127)&&(k != 16)&&(k != 10)&&(k != 17)&&(k != 18)) {
    input[step] = keyCode;
    step++;
    if (step > textMax-2) {
      step = textMax-2;
    }
  }
}
